<?php
/*
Name: bloo.init
Purpose: Initializes a Bloo blog
Author: Bill Roberts
Created: April, 2005
$Revision: 1.22 $

Copyright (C) 2005-2008  Bill Roberts (bill@outofthebloo.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

GPL URL: http://www.gnu.org/licenses/gpl.html

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/* set the bloo version */
define( "BLOO_VERSION", "1.00" );

require_once( "bloo.config.php" );
require_once( "bloo_session.classes.php" );

/**************************************************************/
/* Bloo initializations                                       */
/**************************************************************/
/* create the session */
$_session = new BlooSession( );

$_session->loadDescriptor( "./", "bloo_session.descriptor.xml", FILE_BASED );

/* initialize the session (connect to the db, load settings, overlays, etc */
$_session->initialize( $_server, $_database, $_userId, $_password, $_settingsTable );

if ( $_session->isError( MSG_FATAL ) ) {
   /* here's the error message for if everything went to heck in a handcart */
   /* gather errors up - will display in a special error template */
   $errors = "";
   while ( $error = $_session->getError( ) ) {
      if ( $errors > "" ) {
         $errors .= "<br />";
      }
      $errors .= $error;
   }

   /* special check - if Bloo hasn't been installed, the error string below will probably be returned,
      (depending on your version of MySql). Produce a nicer message */
   if ( strpos( $errors, "list' doesn't exist" ) ) {
      $errors = "It looks like Bloo may not yet be installed on this site. If you are an administrator, please run " .
         "the install program to install it.";
   }

   $s = new PhooDisplay( $_session, $_session );
   if ( is_object( $s ) ) {
      $s->securityRole = ROLE_EVERYONE;
      $s->template = "=|BlooSession.error|=";
      $s->process( );

      if ( !$_session->isError( MSG_FATAL ) ) {
         $s->setVar( "bloo_session_error", $errors, "PRIVATE" );
         $s->display( );
      }
      else { /* just echo the error */
         echo $errors;
      }
   }
   else { /* just echo the error */
      echo $errors;
   }
   
   exit;
}

/* write out the http header */
$httpHeader =& $_session->snapOnFactory( "BlooHTTPHeader", $_session );
$httpHeader->process( );
$httpHeader->display( );
?>
