<?php
/* Name: http.classes.php
   Purpose: Sends headers for an http page
   Author: Bill Roberts
   Created: 4/11/2005
   $Revision: 1.2 $

Copyright (C) 2005-2008  Bill Roberts (bill@outofthebloo.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

GPL URL: http://www.gnu.org/licenses/gpl.html

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
class BlooHTTPHeader extends PhooClass {

   var $name = "BlooHTTPHeader";
   var $securityRole = ROLE_EVERYONE;

   function setDescriptor(  ) {
      $this->setAuthor( "Bill Roberts" );
      $this->setVersion( "0.1" );
      $this->setCreateDate( "2005-04-11" );
      $this->setPurpose( "Send http headers for the blog" );
      $this->addModificationHistory( "modified for new role-based security", "2005-10-28" );
   }
   
   /* send the headers */
   function doAction( ) {
      /* a date in the past */
      header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); 
      /* always modified */
      header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
      /* HTTP/1.1 */
      header("Cache-Control: no-store, no-cache, must-revalidate"); 
      header("Cache-Control: post-check=0, pre-check=0", false);
      /* HTTP/1.0 */
      header("Pragma: no-cache");
   }
}
?>
