<?php
/* 
   Name: log.classes.php
   Author: Bill Roberts
   Created: 5/20/2005
   Purpose: SnapOn classes related to logging messages
   $Revision: 1.2 $
   
Copyright (C) 2005-2008  Bill Roberts (bill@outofthebloo.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

GPL URL: http://www.gnu.org/licenses/gpl.html

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
  
class SystemLogWriter extends PhooProcess {
   var $package = "log";
   var $name = "SystemLogWriter";
   var $command = "=|Log.insert|=";
   var $securityRole = ROLE_EVERYONE;   
   
   function setMessage( $logPackage, $logText ) {
      $this->session->setVar( "log_user_id", $this->session->getUserID( ), "POST" );
      $this->session->setVar( "log_package", $logPackage, "POST" );
      $this->session->setVar( "log_text", $logText, "POST" );
   }
   
   function setDescriptor(  ) {
      $this->setAuthor( "Bill Roberts" );
      $this->setVersion( "0.1" );
      $this->setCreateDate( "2005-05-20" );
      $this->setPurpose( "writes messages to the system log" );
      $this->addModificationHistory( "modified for new role-based security", "2005-10-30" );
   }
}

class SystemLogDisplay extends PhooQuery {
   var $name = "SystemLogDisplay";
   var $securityRole = ROLE_POSTER;
   var $command = "=|Log.get.recent|=";
   var $template = "=|Log|=";
   var $templateHeader = "=|Log.header|=";
   var $templateFooter = "=|Log.footer|=";

   function setDescriptor(  ) {
      $this->setAuthor( "Bill Roberts" );
      $this->setVersion( "0.1" );
      $this->setCreateDate( "2005-08-09" );
      $this->setPurpose( "Displays the latest log details" );
      $this->addModificationHistory( "modified for new role-based security", "2005-10-30" );
   }
}
?>
