<?php
/* 
   Name: mail.classes.php
   Author: Bill Roberts
   Created: 8/12/2005
   Purpose: SnapOn classes related to sending and receiving mail
   $Revision: 1.2 $
   
Copyright (C) 2005-2008  Bill Roberts (bill@outofthebloo.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

GPL URL: http://www.gnu.org/licenses/gpl.html

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/


class MailSender extends PhooClass {
   var $package = "mail";
   var $name = "MailSender";
   var $securityRole = ROLE_EVERYONE;
   var $to;
   var $from;
   var $subject;
   var $message;
   var $suppressError = true;
   
   function setDescriptor(  ) {
      $this->setAuthor( "Bill Roberts" );
      $this->setVersion( "0.1" );
      $this->setCreateDate( "2005-08-12" );
      $this->setPurpose( "sends a mail message" );
      $this->addModificationHistory( "modified for new role-based security", "2005-10-30" );
   }

   function setMail( $aTo, $aSubject, $aMessage, $aFrom=null ) {
      $this->to = $aTo;
      $this->subject = $aSubject;
      $this->message = $aMessage;
      $this->from = $aFrom;
   }
   
   function doAction( ) {

      parent::doAction( );
      
      if ( $this->isError( ) ) {
         return;
      }

      /* if from is set, set an additional header */
      if ( isset( $this->from ) ) {
         $header = "From: " . $this->from;
      }
      else {
         $header = null;
      }
      
      /* send the mail */
      $retCode = @mail( $this->to, $this->subject, $this->message, $header );

      if ( !$retCode && !$this->suppressError ) {
         $this->setError( "Could not send email to " . $this->to, MSG_WARNING );
      }
   }
}
?>
