<?php
/* 
   Name: esv_daily_passage
   Author: Bill Roberts
   Created: 4/18/2005

   Purpose: SnapOns related to displaying the ESV daily passage 
   
   $Revision: 1.3 $
   
Copyright (C) 2005-2008  Bill Roberts (bill@outofthebloo.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

GPL URL: http://www.gnu.org/licenses/gpl.html

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.   
*/   
  
class ESVDailyPassage extends PhooRSSReader {
   var $package = "esv_daily_passage";
   var $name = "ESVDailyPassage";
   var $securityRole = ROLE_EVERYONE;
   var $template = "=|ESVDailyPassage|=";
   var $RSSFeed = "http://www.gnpcb.org/esv/share/rss2.0/daily/";
  
   function setDescriptor(  ) {
      $this->setAuthor( "Bill Roberts" );
      $this->setVersion( "0.1" );
      $this->setCreateDate( "2005-04-20" );
      $this->setPurpose( "Displays the English Standard Version daily Bible passage" );
      $this->addModificationHistory( "modified for new role-based security", "2005-10-28" );
   }

   function setVariables( $xmlData ) {
      $this->session->setVar( "esv_daily_passage", 
                              $xmlData[ "RSS" ][0][ "CHANNEL" ][0][ "ITEM" ][0][ "DESCRIPTION" ], "PRIVATE" );
      $this->session->setVar( "esv_daily_passage_reference", 
                              $xmlData[ "RSS" ][0][ "CHANNEL" ][0][ "ITEM" ][0][ "TITLE" ], "PRIVATE" );

      /* note: remove tabs in the copyright - not sure why they are there */
      $copyright = $xmlData[ "RSS" ][0][ "CHANNEL" ][0][ "COPYRIGHT" ];
      $this->session->setVar( "esv_daily_passage_copyright", str_replace( "\t", " ", $copyright ), "PRIVATE" );
      $this->session->setVar( "esv_daily_passage_link", $xmlData[ "RSS.CHANNEL.ITEM.LINK" ][0], "PRIVATE" );
   }
}

?>
